// =====================================================================
//   TMxICMP R|[lg
//                                              Version 1.45 2001/12/07
//                                                   MASAHIRO SUZUKI
// ======================================================================
// 2001/12/07 EƂ肠D6œ悤ɂB
// 2001/02/03 EtOg֎~IvVǉB
// 1999/05/01 ESendEchǒʂ0WSAGetLastError0̏ꍇɂSendEchõX
//              e[^X߂悤ɂB
//            EIPAdress0.0.0.0w肳ꂽƂɑΏB
unit MxICMP;

interface

uses
  Windows, Classes, SysUtils, Forms, Messages, Winsock, MxICMP_MSG;

const
  WM_ASYNCGETHOST = WM_USER + 2;
const
  // IPwb_IvVFlagp
  IPFLAG_DONT_FRAGMENT        = $2; // tOg֎~
  // ICMP Message
  IP_SUCCESS                  = 0;
  IP_STATUS_BASE              = 11000;
  IP_BUF_TOO_SMALL            = (IP_STATUS_BASE + 1);
  IP_DEST_NET_UNREACHABLE     = (IP_STATUS_BASE + 2);
  IP_DEST_HOST_UNREACHABLE    = (IP_STATUS_BASE + 3);
  IP_DEST_PROT_UNREACHABLE    = (IP_STATUS_BASE + 4);
  IP_DEST_PORT_UNREACHABLE    = (IP_STATUS_BASE + 5);
  IP_NO_RESOURCES             = (IP_STATUS_BASE + 6);
  IP_BAD_OPTION               = (IP_STATUS_BASE + 7);
  IP_HW_ERROR                 = (IP_STATUS_BASE + 8);
  IP_PACKET_TOO_BIG           = (IP_STATUS_BASE + 9);
  IP_REQ_TIMED_OUT            = (IP_STATUS_BASE + 10);
  IP_BAD_REQ                  = (IP_STATUS_BASE + 11);
  IP_BAD_ROUTE                = (IP_STATUS_BASE + 12);
  IP_TTL_EXPIRED_TRANSIT      = (IP_STATUS_BASE + 13);
  IP_TTL_EXPIRED_REASSEM      = (IP_STATUS_BASE + 14);
  IP_PARAM_PROBLEM            = (IP_STATUS_BASE + 15);
  IP_SOURCE_QUENCH            = (IP_STATUS_BASE + 16);
  IP_OPTION_TOO_BIG           = (IP_STATUS_BASE + 17);
  IP_BAD_DESTINATION          = (IP_STATUS_BASE + 18);
  IP_ADDR_DELETED             = (IP_STATUS_BASE + 19);
  IP_SPEC_MTU_CHANGE          = (IP_STATUS_BASE + 20);
  IP_MTU_CHANGE               = (IP_STATUS_BASE + 21);
  IP_UNLOAD                   = (IP_STATUS_BASE + 22);
  IP_GENERAL_FAILURE          = (IP_STATUS_BASE + 50);
  IP_PENDING                  = (IP_STATUS_BASE + 255);

type
  // ----------------------------------------------------------------------
  TOnReply   = procedure ( Sender:TObject;
                           Status: Integer;
                           IPAddress:String;
                           RTT: Longword;
                           TTL: Byte;
                           HostName: String
                         ) of object;
  TOnRoute   = procedure ( Sender:TObject;
                           Status: Integer;
                           Hops: Byte;
                           IPAddress: String;
                           RTT: Longword;
                           HostName: String;
                           Done: Boolean
                         ) of object;
  EICMPError = class(Exception);
// ----------------------------------------------------------------------
  TIPAddr   = Longword;   // IPAhX
//  TIPMask   = Longword;   // IPTulbg}XN
//  TIPStatus = Longword;   // APĨ^[Xe[^X
  // ----------------------------------------------------------------------
  PIPINFO   = ^TIPINFO;
  TIPINFO   = packed record
    TTL:      Byte;    // Time To Live
    TOS:      Byte;    // T[rX̃^Cv(Type Of Service)
    IPFlags:  Byte;    // IP wb_[tO
    OptSize:  Byte;    // IvVf[^TCY(MAX:40)
    OptData:  PChar;   // IvVf[^obt@
  end;
  // ----------------------------------------------------------------------
  PICMPECHO = ^TICMPECHO;
  TICMPECHO = packed record
    Address:  TIPAddr; // ReplyԂĂIPAhX
    Status:   Longword;   // IP status value
    RTT:      Longword;   // Round Trip Time (1/100bP)
    DataSize: Word;    // Reply data size
    Reserved: Word;    // \
    Data:     Pointer; // Pointer to reply data buffer
    IpInfo:   TIPINFO; // Reply options
  end;
  // ----------------------------------------------------------------------
  TIcmpCreateFile  = function: THandle; stdcall;
  TIcmpCloseHandle = function(IcmpHandle: THandle): Boolean; stdcall;
  TIcmpSendEcho    = function(IcmpHandle:          THandle;
                              DestinationAddress:  TIPAddr;
                              RequestData:         Pointer;
                              RequestSize:         Word;
                              RequestOptions:      PIPINFO;
                              ReplyBuffer:         Pointer;
                              ReplySize:           Longword;
                              Timeout:             Longword
                             ): Longword; stdcall;
  // ----------------------------------------------------------------------

TMxICMP = class(TComponent)
  protected
    FDontFlagment:      Boolean;
    FWindowHandle     : THandle;
    FDnsLookupBuffer  : array [0..MAXGETHOSTSTRUCT] of Char;
    FDnsLookupHandle  : THandle;
    FpHostEnt         : PHostEnt;
    FDoingNow         : Boolean;
    hICMP:               THandle;
    FCancel:             Boolean;
    FAddress:            String;
    FBlockSize:          Integer;
    FTTL:                Byte;
    FTimeout:            Integer;
    FDelay:              Integer;
    FNumberOfPings:      Integer;
    FOnReply:            TOnReply;
    FOnRoute:            TOnRoute;
    FHostName:           String;
    FHostIP:             String;
    FResolveHostName:    Boolean;
    FWinsockVersion:     String;
    FWinsockHighVersion: String;
    FWinsockDescription: String;
    FWinsockMaxSockets:  Integer;
    FWinsockUdpDg:       Integer;
    IcmpCreateFile:      TIcmpCreateFile;
    IcmpCloseHandle:     TIcmpCloseHandle;
    IcmpSendEcho:        TIcmpSendEcho;
    function    IsIPAddr(Addr: String): Boolean;
    function    GetHostEnt(Addr: String): Boolean;
    function    GetIPAddr(Addr: String): TIPAddr;
    function    IpToHostName(IPAddr: TIPAddr): String;
    procedure   OpenICMP;
    procedure   WndProc(var MsgRec: TMessage);
    procedure   WMAsyncGetHost(var msg: TMessage); message WM_ASYNCGETHOST;
  public
    function    Ping: Boolean;
    function    TraceRoute: Boolean;
    procedure   Cancel;
    function    GetMessageString(Status: Integer): String;
    property    Busy:     Boolean   read  FDoingNow;
    property    WinsockVersion:     String   read  FWinsockVersion;
    property    WinsockHighVersion: String   read  FWinsockHighVersion;
    property    WinsockDescription: String   read  FWinsockDescription;
    property    WinsockMaxSockets:  Integer  read  FWinsockMaxSockets;
    property    WinsockUdpDg:       Integer  read  FWinsockUdpDg;
    constructor Create(Aowner:TComponent); override;
    destructor  Destroy; override;

  published


    property    OnReply:         TOnReply  read    FOnReply
                                           write   FOnReply;
    property    OnRoute:         TOnRoute  read    FOnRoute
                                           write   FOnRoute;
    property    Address:         String    read    FAddress
                                           write   FAddress;
    property    BlockSize:       Integer   read    FBlockSize
                                           write   FBlockSize
                                           default 64;
    property    TTL:             Byte      read    FTTL
                                           write   FTTL
                                           default 255;
    property    Timeout:         Integer   read    FTimeout
                                           write   FTimeout
                                           default 5000;
    property    Delay:           Integer   read    FDelay
                                           write   FDelay
                                           default 1000;
    property    NumberOfPings:   Integer   read    FNumberOfPings
                                           write   FNumberOfPings
                                           default 3;
    property    ResolveHostName: Boolean   read    FResolveHostName
                                           write   FResolveHostName;
    property    DontFlagment:    Boolean   read    FDontFlagment
                                           write   FDontFlagment;
  end;

procedure Register;

implementation

// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
// ----------------------------------------------------------------------
function MxIcmpProc( ahWnd: HWND; auMsg: Integer; awParam: WPARAM; alParam : LPARAM): Integer; stdcall;
var
    Obj    : TMxICMP;
    MsgRec : TMessage;
begin
    Obj    := TMxICMP(GetWindowLong(ahWnd, 0));
    Result := DefWindowProc(ahWnd, auMsg, awParam, alParam);
    if Assigned(Obj) then 
    begin
      if Obj.FCancel then Exit;
      MsgRec.Msg    := auMsg;
      MsgRec.wParam := awParam;
      MsgRec.lParam := alParam;
      Obj.WndProc(MsgRec);
      Result := MsgRec.Result;
    end;
end;
// ----------------------------------------------------------------------
var
  MxIcmpClass: TWndClass = (
        style         : 0;
        lpfnWndProc   : @MxIcmpProc;
        cbClsExtra    : 0;
        cbWndExtra    : SizeOf(Pointer);
        hInstance     : 0;
        hIcon         : 0;
        hCursor       : 0;
        hbrBackground : 0;
        lpszMenuName  : nil;
        lpszClassName : 'MxIcmpWindowClass');
// ----------------------------------------------------------------------
function CreateMxIcmp(Obj: TObject): HWND;
var
    TempClass       : TWndClass;
    ClassRegistered : Boolean;
begin
    MxIcmpClass.hInstance := HInstance;
    ClassRegistered := GetClassInfo(HInstance, MxIcmpClass.lpszClassName, TempClass);

    if not ClassRegistered then 
    begin
       Result := Windows.RegisterClass(MxIcmpClass);
       if Result = 0 then Exit;
    end;

    // bZ[W󂯂_~[̕sWindow𐶐
    Result := CreateWindowEx(WS_EX_TOOLWINDOW,
                           MxIcmpClass.lpszClassName, '', WS_POPUP, 0, 0,
                           0, 0, 0, 0, HInstance,  nil);

   if (Result <> 0) and Assigned(Obj) then
        SetWindowLong(Result, 0, Integer(Obj));
end;
// ----------------------------------------------------------------------
procedure DestroyMxIcmp(Wnd: HWND);
begin
  DestroyWindow(Wnd);
end;
// ----------------------------------------------------------------------
//
// ----------------------------------------------------------------------
{ TMxICMP.WndProc }
procedure TMxICMP.WndProc(var MsgRec: TMessage);
begin
  if FCancel then Exit;
  with MsgRec do 
  begin
    if Msg = WM_ASYNCGETHOST then
      WMAsyncGetHost(MsgRec)
    else
      Result := DefWindowProc(FWindowHandle, Msg, wParam, lParam);
  end;
end;
// ----------------------------------------------------------------------
procedure TMxICMP.WMAsyncGetHost(var msg: TMessage);
var
  Error   : Word;
begin
  if FCancel then Exit;
  if Longword(msg.wParam) <> Longword(FDnsLookupHandle) then
    Exit;
  Error := Msg.LParamHi;
  if Error = 0 then
    FpHostEnt := PHostEnt(@FDnsLookupBuffer)
  else
    FpHostEnt := nil;
  FDnsLookupHandle := 0;
end;
// ----------------------------------------------------------------------
{ TMxICMP.Create }
constructor TMxICMP.Create(Aowner:TComponent);
var
  wsaData: TWSAData;
  nRC: Integer;
begin
  inherited create(AOwner);
  FDoingNow        := False;
  FTimeout         := 5000;
  FBlockSize       := 64;
  FTTL             := 255;
  FDelay           := 1000;
  FNumberOfPings   := 3;
  FResolveHostName := True;
  FWindowHandle    := CreateMxIcmp(Self);
  FDontFlagment    := False;
  hICMP            := INVALID_HANDLE_VALUE;
  nRC := WSAStartup($101, wsaData);      // Winsock1.1 
  if nRC <> 0 then
    raise EICMPError.Create('Winsock ̏o܂łB');
  if wsaData.wVersion <> $0101 then
    raise EICMPError.Create('Winsock  v1.1 ݊œł܂B');
  FWinsockVersion     := IntToStr(LOBYTE(wsaData.wVersion))  +
                          '.' +
                         IntToStr(HIBYTE(wsaData.wVersion));
  FWinsockHighVersion := IntToStr(LOBYTE(wsaData.wHighVersion)) +
                         '.' +
                         IntToStr(HIBYTE(wsaData.wHighVersion));
  FWinsockDescription := wsaData.szDescription;
  FWinsockMaxSockets  := wsaData.iMaxSockets;
  FWinsockUdpDg       := wsaData.iMaxUdpDg;
  OpenICMP;
end;
// ----------------------------------------------------------------------
procedure TMxICMP.Cancel;
begin
  FCancel := True;
  if FDnsLookupHandle <> 0 then 
  begin
    WSACancelAsyncRequest(FDnsLookupHandle);
    FDnsLookupHandle := 0;
  end;
end;

// ----------------------------------------------------------------------
{ TMxICMP.Destroy }
destructor TMxICMP.Destroy;
begin
  inherited destroy;
  IcmpCloseHandle(hICMP);
  WSACleanup;
  DestroyMxIcmp(FWindowHandle);
end;
// ----------------------------------------------------------------------
{ TMxICMP.OpenICMP }
procedure TMxICMP.OpenICMP;
begin
  hICMP := LoadLibrary('ICMP.DLL');
  if hICMP = 0 then
    raise EICMPError.Create('Kvȃt@C ICMP.DLL ܂B');
  @IcmpCreateFile  := GetProcAddress(hICMP, 'IcmpCreateFile');
  @IcmpCloseHandle := GetProcAddress(hICMP, 'IcmpCloseHandle');
  @IcmpSendEcho    := GetProcAddress(hICMP, 'IcmpSendEcho');
  if (@IcmpCreateFile  = Nil)  or
     (@IcmpCloseHandle = Nil)  or
     (@IcmpSendEcho    = Nil)  then
    raise EICMPError.Create('ICMP.DLL ̃vZX擾o܂B');
end;
// ----------------------------------------------------------------------
{ TMxICMP.GetMessageString }
function TMxICMP.GetMessageString(Status: Integer): String;
begin
  case Status of
    -1                       : Result := MxICMP_MSG_UNKNOWN_HOST;
    IP_SUCCESS               : Result := MxICMP_MSG_IP_SUCCESS;
    IP_BUF_TOO_SMALL         : Result := MxICMP_MSG_IP_BUF_TOO_SMALL;
    IP_DEST_NET_UNREACHABLE  : Result := MxICMP_MSG_IP_DEST_NET_UNREACHABLE  ;
    IP_DEST_HOST_UNREACHABLE : Result := MxICMP_MSG_IP_DEST_HOST_UNREACHABLE ;
    IP_DEST_PROT_UNREACHABLE : Result := MxICMP_MSG_IP_DEST_PROT_UNREACHABLE ;
    IP_DEST_PORT_UNREACHABLE : Result := MxICMP_MSG_IP_DEST_PORT_UNREACHABLE ;
    IP_NO_RESOURCES          : Result := MxICMP_MSG_IP_NO_RESOURCES;
    IP_BAD_OPTION            : Result := MxICMP_MSG_IP_BAD_OPTION;
    IP_HW_ERROR              : Result := MxICMP_MSG_IP_HW_ERROR;
    IP_PACKET_TOO_BIG        : Result := MxICMP_MSG_IP_PACKET_TOO_BIG;
    IP_REQ_TIMED_OUT         : Result := MxICMP_MSG_IP_REQ_TIMED_OUT;
    IP_BAD_REQ               : Result := MxICMP_MSG_IP_BAD_REQ;
    IP_BAD_ROUTE             : Result := MxICMP_MSG_IP_BAD_ROUTE;
    IP_TTL_EXPIRED_TRANSIT   : Result := MxICMP_MSG_IP_TTL_EXPIRED_TRANSIT;
    IP_TTL_EXPIRED_REASSEM   : Result := MxICMP_MSG_IP_TTL_EXPIRED_REASSEM;
    IP_PARAM_PROBLEM         : Result := MxICMP_MSG_IP_PARAM_PROBLEM;
    IP_SOURCE_QUENCH         : Result := MxICMP_MSG_IP_SOURCE_QUENCH;
    IP_OPTION_TOO_BIG        : Result := MxICMP_MSG_IP_OPTION_TOO_BIG;
    IP_BAD_DESTINATION       : Result := MxICMP_MSG_IP_BAD_DESTINATION;
    IP_ADDR_DELETED          : Result := MxICMP_MSG_IP_ADDR_DELETED;
    IP_SPEC_MTU_CHANGE       : Result := MxICMP_MSG_IP_SPEC_MTU_CHANGE;
    IP_MTU_CHANGE            : Result := MxICMP_MSG_IP_MTU_CHANGE;
    IP_UNLOAD                : Result := MxICMP_MSG_IP_UNLOAD;
    IP_GENERAL_FAILURE       : Result := MxICMP_MSG_IP_GENERAL_FAILURE;
    IP_PENDING               : Result := MxICMP_MSG_IP_PENDING;
    else                       Result := MxICMP_MSG_UNKNOWN_ERROR;
  end;
end;
// ----------------------------------------------------------------------
function TMxICMP.IsIPAddr(Addr: String): Boolean;
var
  szAddr: array[0..256] of char;
  lHost: TIPAddr;
begin
  StrPCopy(szAddr, Trim(Addr));
  lHost := inet_addr(szAddr);
  if lHost = Longword(INADDR_NONE) then
    Result := False
  else
    Result := True;
end;
// ----------------------------------------------------------------------
function TMxICMP.GetHostEnt(Addr: String): Boolean;
var
  szAddr: array[0..256] of char;
  iaHost: TInAddr;
begin
  Result := False;

  if IsIPAddr(Addr) then 
  begin
    StrPCopy(szAddr, Trim(Addr));
    iaHost.S_addr := inet_addr(szAddr);
    FDnsLookupHandle := WSAAsyncGetHostByAddr(FWindowHandle,
                                              WM_ASYNCGETHOST,
                                              @iaHost,
                                              SizeOF(TInAddr),
                                              AF_INET,
                                              @FDnsLookupBuffer,
                                              MAXGETHOSTSTRUCT);
  end else 
  begin
    FDnsLookupHandle := WSAAsyncGetHostByName(FWindowHandle,
                                              WM_ASYNCGETHOST,
                                              @Addr[1],
                                              @FDnsLookupBuffer,
                                              MAXGETHOSTSTRUCT)
  end;

  if FDnsLookupHandle <> 0 then 
  begin
    while (FDnsLookupHandle <> 0) and (not FCancel) do 
    begin
      Application.ProcessMessages;
      Sleep(10);
    end;
    if FpHostEnt <> nil then
      Result := True
  end;
end;
// ----------------------------------------------------------------------
{TMxICMP.GetIPAddress}
function TMxICMP.GetIPAddr(Addr: String): TIPAddr;
var
  szAddr: array[0..256] of char;
begin
  if IsIPAddr(Addr) then 
  begin
    StrPCopy(szAddr, Trim(Addr));
    Result := inet_addr(szAddr);
  end else 
  begin
    if GetHostEnt(Address) then 
      Result := Longword(PInAddr(FpHostEnt^.h_addr_list^)^)
    else
      Result := $FFFFFFFF;
  end;
end;
// ----------------------------------------------------------------------
{TMxICMP.IpToHostName}
function TMxICMP.IpToHostName(IPAddr: TIPAddr): String;
var
  szAddr: array[0..256] of char;
begin
  Result := '';
  StrPCopy(szAddr, inet_ntoa(TInAddr(IPAddr)));
  if IPAddr <> Longword(INADDR_NONE) then
    if GetHostEnt(StrPas(szAddr)) then
      Result := StrPas(FpHostEnt^.h_name);
end;
// ----------------------------------------------------------------------
{TMxICMP.Ping}
function TMxICMP.Ping: Boolean;
var
  LookupDone: Boolean;
  IpInfo:     TIPINFO;
  pEchoReply: PICMPECHO;
  i, BufSize,
  Res:  Integer;
  Tick: Longword;
  pReqData,
  pEchoBuf:   Pointer;
  lAddr:      TIPAddr;
  HostName, IPStr: String;
begin

  Result         := not FDoingNow;
  if FDoingNow then Exit;

  FDoingNow      := True;
  try
    FCancel        := False;
    LookupDone     := False;
    IpInfo.TTL     := FTTL;
    IpInfo.Tos     := 0;

    if FDontFlagment then
      IpInfo.IPFlags := IPFLAG_DONT_FRAGMENT
    else
      IpInfo.IPFlags := 0;

    IpInfo.OptSize := 0;
    IpInfo.OptData := nil;
    lAddr          := $FFFFFFFF;
    FpHostEnt      := nil;
    BufSize        := SizeOf(TICMPECHO) + FBlockSize;
    hICMP          := IcmpCreateFile;
  
    GetMem(pReqData, FBlockSize);
    GetMem(pEchoBuf, BufSize);
    try
      FillChar(pReqData^, FBlockSize, #$A7);
      for i := 1 to FNumberOfPings do 
      begin  // PingJԂ
        if FCancel then Break;
        Application.ProcessMessages;
        if lAddr = $FFFFFFFF then 
        begin
          lAddr := GetIPAddr(FAddress);
          if lAddr = $FFFFFFFF then 
          begin
            if Assigned(FOnReply) and (not FCancel) then  // Cxg
               FOnReply( Self, -1, '0.0.0.0', 0, 0, '');
          end else 
          begin
            LookupDone := True;
            if FResolveHostName then
              if FpHostEnt = nil then
                HostName := IpToHostName(lAddr)
              else
                HostName := StrPas(FpHostEnt^.h_name);
          end;
        end;
        // zXg₢킹ɐƂPings
        if LookupDone then 
        begin
          Res := IcmpSendEcho( hICMP,       // IcmpCreateFileō쐬nh
                               lAddr,       // IPAhX
                               pReqData,    // Sendobt@̃|C^
                               FBlockSize,  // Sendobt@̃TCY
                               @IpInfo,     // NGXgIvV
                               pEchoBuf,    // Replyobt@̃|C^
                               BufSize,     // Replyobt@̃TCY
                               FTimeout     // ^CAEg
                             );
          pEchoReply := PICMPECHO(pEchoBuf);
          Application.ProcessMessages;
  
          if Res = 0 then 
          begin
            if WSAGetLastError <> IP_SUCCESS then 
              pEchoReply^.Status := WSAGetLastError;
            IPStr := '0.0.0.0';
          end else
            IPStr := StrPas(inet_ntoa(TInAddr(pEchoReply^.Address)));
          // SendEcho ̖߂lu0v̏ꍇ̓G[łidlOIPAhX or RequestTimedOutj
          if Assigned(FOnReply) and (not FCancel) then 
          begin // Cxg
            FOnReply( Self,
                      pEchoReply^.Status,
                      IPStr,
                      pEchoReply^.RTT,
                      pEchoReply^.IpInfo.TTL,
                      HostName
                    );
          end;
        end;
        // JԂWait
        Tick := GetTickCount;
        while (Tick + Longword(FDelay)) > GetTickCount do 
        begin
          if FCancel then Break;
          Application.ProcessMessages;
          Sleep(10);  // ꂪCPU̎gpˏオ :-)
        end;
      end;
    finally
      FreeMem(pEchoBuf);
      FreeMem(pReqData);
    end;
    IcmpCloseHandle(hICMP);
  finally
    FDoingNow := False;
  end;
end;
// ----------------------------------------------------------------------
{TMxICMP.TraceRoute}
function TMxICMP.TraceRoute: Boolean;
var
  lAddr:     TIPAddr;
  IpInfo:    TIPINFO;
  EchoReply: TICMPECHO;
  Done:      Boolean;
  Res, i:    Integer;
  HostName, IPStr:  String;
begin

  Result         := not FDoingNow;
  if FDoingNow then Exit;

  FDoingNow := True;
  try
    FCancel  := False;
    Done     := False;
    hICMP    := IcmpCreateFile;
    lAddr    := GetIPAddr(FAddress);
    if lAddr = $FFFFFFFF then 
    begin
      if Assigned(FOnRoute) and (not FCancel) then
        FOnRoute( Self, -1, 1, '0.0.0.0', 0, '', True);
    end else 
    begin
      i := 0;
      while (i < FTTL) do 
      begin
        if Done or FCancel then Break;
        Inc(i);
        if i >= FTTL then Done := True;
        IpInfo.TTL     := i;
        IpInfo.Tos     := 0;

        if FDontFlagment then
          IpInfo.IPFlags := IPFLAG_DONT_FRAGMENT
        else
          IpInfo.IPFlags := 0;

        IpInfo.OptSize := 0;
        IpInfo.OptData := nil;
        Res := IcmpSendEcho( hICMP,              // IcmpCreateFileō쐬nh
                             lAddr,              // IPAhX
                             nil,                // Sendobt@̃|C^
                             0,                  // Sendobt@̃TCY
                             @IpInfo,            // NGXgIvV
                             @EchoReply,         // Replyobt@̃|C^
                             SizeOf(TICMPECHO),  // Replyobt@̃TCY
                             FTimeout            // ^CAEg
                           );
        if Res = 0 then 
        begin
          if Assigned(FOnRoute) and (not FCancel) then 
          begin
            if EchoReply.Status = IP_SUCCESS then
              EchoReply.Status := WSAGetLastError;
            if EchoReply.Status <> IP_REQ_TIMED_OUT then
              Done := True;
            FOnRoute( Self,
                      EchoReply.Status,
                      i,
                      '0.0.0.0',
                      0,
                      '',
                      Done);
          end;
        end else 
        begin
          IPStr := StrPas(inet_ntoa(TInAddr(EchoReply.Address)));
          if FResolveHostName then 
          begin
            if GetHostEnt(IPStr) then
              HostName := StrPas(FpHostEnt^.h_name)
            else
              HostName := '';
          end;
          if EchoReply.Address = lAddr then
            Done := True;
          if (EchoReply.Status = IP_SUCCESS) or 
             (EchoReply.Status = IP_TTL_EXPIRED_TRANSIT) then
          begin
            if Assigned(FOnRoute) and (not FCancel) then
              FOnRoute( Self,
                        0,
                        i,
                        IPStr,
                        EchoReply.RTT,
                        HostName,
                        Done
                      );
          end else 
          begin
            Done := True;
            if Assigned(FOnRoute) and (not FCancel) then
              FOnRoute( Self,
                        EchoReply.Status,
                        i,
                        IPStr,
                        EchoReply.RTT,
                        HostName,
                        Done
                      );
          end;
        end;
      end;
    end;
    IcmpCloseHandle(hICMP);
  finally
    FDoingNow := False;
   end;
end;
  
// ----------------------------------------------------------------------
procedure Register;
begin
  RegisterComponents('masa-s', [TMxICMP]);
end;
// ----------------------------------------------------------------------

end.