unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MxICMP, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    MxICMP1: TMxICMP;
    Memo1: TRichEdit;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure MxICMP1Reply(Sender: TObject; Status: Integer;
      IPAddress: String; RTT: Cardinal; TTL: Byte; HostName: String);
    procedure Button2Click(Sender: TObject);
    procedure MxICMP1Route(Sender: TObject; Status: Integer; Hops: Byte;
      IPAddress: String; RTT: Cardinal; HostName: String; Done: Boolean);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  MxICMP1.Address       := Edit1.Text;
  MxICMP1.NumberOfPings := StrToIntDef(Edit2.Text,    3);
  MxICMP1.Timeout       := StrToIntDef(Edit3.Text, 1000);
  MxICMP1.TTL           := StrToIntDef(Edit4.Text,  255);
  MxICMP1.Delay         := StrToIntDef(Edit5.Text, 1000);
  MxICMP1.BlockSize     := StrToIntDef(Edit6.Text,   32);

  Button1.Enabled := False;
  Button2.Enabled := False;
  Button3.Enabled := True;

  if not MxICMP1.Ping then
    Memo1.Lines.Add('*** BUSY! ***');
  Memo1.Lines.Add('---------- PING END ----------');

  Button1.Enabled := True;
  Button2.Enabled := True;
  Button3.Enabled := False;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  MxICMP1.Address := Edit1.Text;
  MxICMP1.Timeout       := StrToIntDef(Edit3.Text, 1000);
  MxICMP1.TTL           := StrToIntDef(Edit4.Text, 255); 

  Button1.Enabled := False;
  Button2.Enabled := False;
  Button3.Enabled := True;

  if not MxICMP1.TraceRoute then
    Memo1.Lines.Add('*** BUSY! ***');
  Memo1.Lines.Add('---------- TRACEROUTE END ----------');

  Button1.Enabled := True;
  Button2.Enabled := True;
  Button3.Enabled := False;

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if MxICMP1.Busy then
    MxICMP1.Cancel;
end;

procedure TForm1.MxICMP1Reply(Sender: TObject; Status: Integer;
  IPAddress: String; RTT: Cardinal; TTL: Byte; HostName: String);
var
  Msg: String;
begin

  if Status = 0 then
    Msg := Format('Reply from %s: bytes=%d time=%dms TTL=%d',
                  [IPAddress, MxICMP1.BlockSize, RTT, TTL])
  else
    Msg := MxICMP1.GetMessageString(Status);

  Memo1.Lines.Add(Msg);

end;

procedure TForm1.MxICMP1Route(Sender: TObject; Status: Integer; Hops: Byte;
  IPAddress: String; RTT: Cardinal; HostName: String; Done: Boolean);
var
  Msg: String;
begin
  if Status = 0 then
    Msg := Format(' %2d %6d ms %s[%s]', [Hops, RTT, HostName, IPAddress])
  else
    Msg := Format(' %2d       *   %s', [Hops, MxICMP1.GetMessageString(Status)]);

  Memo1.Lines.Add(Msg);
  
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Memo1.Lines.Clear;
end;

end.
